;$Id: dave_dialog_pickfile.pro,v 1.3 2002/09/27 17:42:28 jmspark Exp $
;
; DAVE_Dialog_Pickfile is a wrapper for dialog_pickfile.
; It changes the current directory to the one
;  that the picked file is located
;  and sets !dave_defaults accordingly.
;
function dave_dialog_pickfile $
	, read = read $
	, write = write $
	, _extra = _extra

	defsysv, '!dave_defaults', exists=exists
	if exists then exists = exists * ptr_valid( !dave_defaults )

	cd, current = current

	if exists then begin

		if keyword_set( write ) then begin

			if current ne (*!dave_defaults).workDir then $
				cd, (*!dave_defaults).workDir

		endif else begin

			if current ne (*!dave_defaults).datDir then $
				cd, (*!dave_defaults).datDir

		endelse

	endif

	; Pick the files.
	files = dialog_pickfile( read = read, write = write, _extra = _extra )
	file = files[0]
	if file eq '' then return, file

	; Call davesysvars to make sure !windows & !delimiters are present.
	davesysvars
	match = '.*' + !delimiter
	if !windows then match = match + !delimiter
	;
	dir = stregex( file, match, /extract ) ; Select only the directory part.
	message, 'Chaning directory to ' + dir, /continue
	cd, dir

	if exists then begin

		if keyword_set( read ) then begin

			(*!dave_defaults).datDir = dir

		endif

		if keyword_set( write ) then begin

			(*!dave_defaults).workDir = dir

		endif

	endif

	dir = stregex( file, match, /extract )
	message, 'Changing directory to ' + dir, /continue
	cd, dir

	return, files

end