;$Id: trifenestra__define.pro,v 1.11 2002/09/27 17:41:50 jmspark Exp $
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************

@rasdfiles
@trifenestra_psd

;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
;
; Event Handlers
;
pro trifenestra_event, event
	widget_control, event.top, get_uvalue = oTop
	oTop -> event_handler, event
end
;*******************************************************************************
pro trifenestra::event_handler, event

	; Grab UVALUE.
	widget_control, event.id, get_uvalue = uvalue
	if n_elements( uvalue ) eq 0 then begin
		result = dialog_message(/error $
			, 'An Empty UVALUE Encountered.' $
			)

		return
	endif

	; Is UVALUE an object reference?
	if obj_valid( uvalue ) then begin
	if obj_class( uvalue ) eq 'TRIFENESTRA_BUTTON' then begin
		uvalue -> GetProperty, name=name, selection=selection
		call_method, name, self, event
		return
	endif	; 'TRIFENESTRA_BUTTON'
	endif	; obj_valid

	; UVALUE must be a string.
	message_string = 'UVALUE = ' + uvalue
	message, message_string, /continue
	call_method, uvalue, self, event
	return

end
;*******************************************************************************



;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
;
;	Cleans up when the widget dies.
;
pro trifenestra_cleanup, tlb

	widget_control, tlb, get_uvalue=self

	obj_destroy, self

	return
end

;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
; trifenestra::dismiss
;
; Requires
;	trifenestra::dave_save, event
;
pro trifenestra::dismiss, event

	inPtr = (*self.daveStatePtr).inPtr

	;dataStrPtr = (*inPtr).dataStrPtr
	;treatmentPtr = (*dataStrPtr).commonStr.treatmentPtr

	; Ask and save the workspace.
	;if n_elements( *treatmentPtr ) gt 1 then begin

	;	text = 'Do you want to save your workspace?'
  ;		response = dialog_message(dialog_parent = self.tlb,text,/question)
  ;		if strupcase(response) eq 'YES' then begin
   ; 		self->file_write_dave, event
  	;	endif

	;endif

	; Do some more if the program runs as a part of DAVE.
	if (*self.daveStatePtr).runFlag eq 1 then begin

		pTmp = inPtr
		if self.oDave -> _self2dave( davePtr = davePtr ) then begin
			;(*self.daveStatePtr).inPtr = ptr_new(*davePtr)
			inPtr = davePtr
			heap_free, pTmp

		endif

		; Generate an event so that the parent widget is notified.
  		s = size((*self.daveStatePtr).notifyIDs)
  		print, 'NotifyIDs = ', (*self.daveStatePtr).notifyIDs
  		if s[0] eq 1 then count = 0 else count = s[2]-1

  		for j = 0,count do begin

    		TASReducePSDInfo = {TASREDUCEEVENT,$
        		ID:(*self.daveStatePtr).notifyIDs[0,j],$
            	Top:(*self.daveStatePtr).notifyIDs[1,j],$
            	Handler:0l,$
            	;inPtr:(*self.daveStatePtr).inPtr $
            	inPtr:inPtr $
            	}

			print, 'DAVE Still Valid? ', dave_valid( inPtr )

    		if widget_info((*self.daveStatePtr).notifyIDs[0,j],/valid_id) then begin
      			widget_control, (*self.daveStatePtr).notifyIDs[0,j] $
      				,send_event = TASReducePSDInfo
      			print, 'Event sent to ', (*self.daveStatePtr).notifyIDs[0,j]
    		endif
  		endfor
	endif

widget_control, self.tlb, /destroy

end



;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************


;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************

;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************

;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
;
; Variable Initialization
;
;	Allows to start from a dummy data set.
;
pro trifenestra::initvar

self.intensity = ptr_new([1])
self.x_bp = ptr_new([1])
self.y_bp = ptr_new([1])
self.dy_bp = ptr_new([1])
self.x_lp = ptr_new([1])
self.y_lp = ptr_new([1])
self.dy_lp = ptr_new([1])
self.IntensityCopy = ptr_new([1],/no_copy)
self.error = ptr_new([1])
self.errorCopy = ptr_new([1],/no_copy)
self.q = ptr_new([1])
self.qCopy = ptr_new([1])
self.hw = ptr_new([1])
self.angle = ptr_new([1])
; self.dcs_bkgd = 0 ; no bkgd subtraction

return

end

;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
; The idea of the init_draw is to have the initial plot in the pixmap window.
; Once the plot is stored there, it can be restored after any mouse action.
; The question is, what is the difference between this and updateimage?
;
pro trifenestra::init_draw ; , xtitle, ytitle, title

	if not obj_valid( self.oDave ) then return

	; Check the size of the picture.
	; If it is too big, rebin the data before displaying.
	; Since a copy already exists at self.oCopy, there is no need to worry.
	qty_dimensions = self.oDave -> get_dimensions()
	if qty_dimensions[0] ge self.xsize / 2 then begin
		self.xrebin = 2 * qty_dimensions[0] / self.xsize
		message, 'Setting xrebin to ' +string( self.xrebin ), /continue
		self -> widget_control, 'xrebin', set_value = self.xrebin
	endif
	if qty_dimensions[1] ge self.ysize / 2 then begin
		self.yrebin = 2 * qty_dimensions[1] / self.ysize
		self -> widget_control, 'yrebin', set_value = self.yrebin
	endif

	; Rebin the data.
	if self.xrebin gt 1 or self.yrebin gt 1 then begin
		self.oDave -> rebin_grid, group = [ self.xrebin, self.yrebin ]
	endif

	; *** Labels.
	self.oDave -> get_label, xlabel=xtitle, ylabel=ytitle, histlabel=title
	print, title
	print, xtitle
	print, ytitle
	if n_elements( xtitle ) ne 1 then xtitle = 'X Label'
	if n_elements( ytitle ) ne 1 then ytitle = 'Y Label'
	if n_elements( title ) ne 1 then title = 'HIST Label'

	; Find title widget IDs and set titles.
	self -> widget_control,'title', set_value=title
	self -> widget_control, 'xtitle' , set_value=xtitle
	self -> widget_control, 'ytitle', set_value=ytitle



	; Make the labels beautiful.
	xtitle = trifenestra_beautify_string( xtitle )
	ytitle = trifenestra_beautify_string( ytitle )
	title = trifenestra_beautify_string( title )


	; Draw to the pixmap window.
	wset, self.pixmapid

	!p.noerase = 0
	!p.charsize = !trifenestra.mainWindowCharSize

	self.oDave -> get_range, xrange=xrange, yrange=yrange, frange=frange
	!x.range = xrange
	!y.range = yrange
	!z.range = frange

;lis = where(*self.intensity gt -1e30)
	; It is not right to hard-code such a number.
	; lis is a list of index that have 'real' data.
;zmin = min((*self.intensity)[lis])
;zmax = max((*self.intensity)[lis])

	self -> widget_control, 'zmin', set_value=frange[0]
	self -> widget_control, 'zmax', set_value=frange[1]
	; Sending values to those widgets.
	; Is it really necessary to do things like this?

	; Plot the conture
	self.oDave -> view $
		, pos= !trifenestra.plotPosition $
		, xtitle = xtitle, ytitle = ytitle, title = title

	; Notify the ranges to other windows.
	!trifenestra.bottomPanelState.bang_x.range = xrange
	!trifenestra.bottomPanelState.bang_y.range = frange
	!trifenestra.leftPanelState.bang_y.range = frange
	!trifenestra.leftPanelState.bang_y.range = yrange


	; maketable
		; Strange...

	; !p = *self.bangp
	; !x = *self.bangx
	; !y = *self.bangy
	; !z = *self.bangz



	wset,self.cwinid
	device,copy = [0,0,self.xsize,self.ysize,0,0,self.pixmapid]

	!trifenestra.mainWindowState = idl_state_save()


end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::_set $
	; PLOT related
	, ix_plot_symbol=ix_plot_symbol $
	, iy_plot_symbol=iy_plot_symbol

	if n_elements( ix_plot_symbol ) eq 1 then $
		self.ix_plot_symbol = ix_plot_symbol

	if n_elements( iy_plot_symbol ) eq 1 then $
		self.iy_plot_symbol = iy_plot_symbol

end

;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
function trifenestra::init, notifyIDs, inPtr, group_leader=group_leader
	; notifyIDs : Widget IDs of the widgets
	;             that must be notified when this program closes.
	; inPtr : Pointer to the data structure.
	;         Equivalent to pState.
	; group_leader : The widget ID of the group leader widget.

	; Define system variables.
	trifenestra_sysvars
	self.wIDs = obj_new('oHash', null = 0L)

	!trifenestra.self = self

	; Included programs
	trifenestra_convert
	trifenestra_math

	; Check whether the program is a stand-alone or not.
	if dave_valid( inPtr ) then begin

		message, 'Running as a part of DAVE', /continue
		dave_runFlag = 1

	endif else begin

		message, 'Running as a stand alone', /continue
		dave_makeDAVEptr, davePtr = inPtr
		notifyIDs = [0L, 0L]
		group_leader = 0
		dave_runFlag = 0

	endelse

	; Store the previous states.
 	!trifenestra.idl_state = idl_state_save()

	; Create a DAVE state pointer.
	daveState = $
		{ inPtr:inPtr $
		, notifyIDs:notifyIDs $
		, group_leader:group_leader $
		, runFlag:dave_runFlag $
		}
	self.daveStatePtr = ptr_new( daveState )



	; Create initial DAVE object.
	self.oDave = obj_new('oDave')

; Assign dummy data to the variables
; because the sizes of them are used to determine
; the existence of the data. -> a bad idea.
; Therefore, I am adding the following line.
self.exist = 0 ; Sungil's addition

self.intensity = ptr_new(/allocate_heap)

self.IntensityCopy = ptr_new(/allocate_heap)
self.error = ptr_new(/allocate_heap)
self.errornobin = ptr_new(/allocate_heap)
self.errorCopy = ptr_new(/allocate_heap)
self.angle = ptr_new(/allocate_heap)
self.q = ptr_new(/allocate_heap)
self.qCopy = ptr_new(/allocate_heap)
self.hw = ptr_new(/allocate_heap)

self.x_bp = ptr_new(/allocate_heap)
self.y_bp = ptr_new(/allocate_heap)
self.dy_bp = ptr_new(/allocate_heap)
self.x_lp = ptr_new(/allocate_heap)
self.y_lp = ptr_new(/allocate_heap)
self.dy_lp = ptr_new(/allocate_heap)


; Now it creates widgets.
self -> createwidgets

if dave_valid( inPtr, /full ) then begin

	self -> file_ready_objects

	if self.oDave -> _dave2self( davePtr = inPtr ) then begin

		message, 'DAVE structure imported successfully.', /continue
		self -> convert_oDave2internal, self.oDave
		self -> file_copy_objects

	endif else begin

		message, 'DAVE structure is unrecognizable.', /continue


	endelse

endif

	self.ix_plot_symbol = 3
	self.iy_plot_symbol = 3

return, 1

end

;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
pro trifenestra::cleanup

self->dismiss

obj_destroy, self.oDave

ptr_free, self.bkgd
ptr_free, self.Intensity, self.IntensityCopy
ptr_free, self.error, self.errorCopy
ptr_free, self.angle, self.q, self.qCopy
ptr_free, self.hw
ptr_free, self.x_lp, self.y_lp, self.dy_lp
ptr_free, self.bangp_lp, self.bangx_lp, self.bangy_lp
ptr_free, self.x_bp, self.y_bp, self.dy_bp
ptr_free, self.bangp_bp, self.bangx_bp, self.bangy_bp
ptr_free, self.bangp, self.bangx, self.bangy, self.bangz, self.bangz_reset

if (*self.daveStatePtr).runFlag eq 0 then begin

	heap_free, self.daveStatePtr

endif


if self.pixmapid ne 0 then wdelete,self.pixmapid

trifenestra_sysvars_cleanup

; Restore the original color table.
idl_state_restore, !trifenestra.idl_state

return

end


;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
;
; trifenestra Data Structure
;
pro trifenestra__define

	void ={ trifenestra $

		; System Variables Moved Over From TRIFENESTRA_SYSVARS
		, wIDs:obj_new() $

		; Define the variables from the Dave Project.
		, daveStatePtr:ptr_new() $

		, oDAVE:obj_new() $
			; Current oDAVE object.

		, oRaw:obj_new() $
			; Raw data. It may not be available.
		, isRaw:0B $
			; if set, oRaw exists.
		, rawButtonString:['',''] $

		, oDaveCopy: obj_new() $


		, oDAVEptr:ptr_new() $
			; Array of oDAVE objects.

		; Widget ID's
		, tlb:0L $ ; Top-Level-Base
		, leftbase:0L $ ; Left Base
		, wCommand:0L $	; Command Widget

		; Data

		, exist:0 $ ; If set, the data exist.
			; We need to replace 'if n_elements( data_array ) gt 2'
			; with 'if self.exist'.

		, Ei: 0d $ ; Incoming Beam Energy
		, bkgd:ptr_new() $	; Background

		, Intensity:ptr_new() $	; Intensity
		, IntensityCopy:ptr_new() $ ; Backup of Intensity


		, error:ptr_new() $ ; Error
		, errorCopy:ptr_new() $ ; Backup of Error
		, errornobin:ptr_new() $ ; ?

		, angle:ptr_new() $ ; 1D (!) Array of Angles
		, q:ptr_new() $ ; Wavevector
		, qCopy:ptr_new() $ ; Backup of Wavevector

		, hw:ptr_new() $ ; Energy

		; Left Panel
		, lpwinid:0L, pixmapid_lp:0 $ ; Window & Pixmap ID
		, xsize_lp:0, ysize_lp:0 $ ; Window Size
		, x_lp:ptr_new() $ ; Vertical Axis
		, y_lp:ptr_new() $ ; Horizontal Data
		, dy_lp:ptr_new() $ ; Error of y_lp
		, bangp_lp:ptr_new() $ ; !p
		, bangx_lp:ptr_new() $ ; !x
		, bangy_lp:ptr_new() $ ; !y
		, togirange_lp:0 $ ; If set, I range changes.




		; Bottom Panel
		, bpwinid:0L, pixmapid_bp:0 $ ; Window & Pixmap ID
		, xsize_bp:0, ysize_bp:0 $ ; Window Size
		, x_bp:ptr_new() $
		, y_bp:ptr_new() $
		, dy_bp:ptr_new() $
		, bangp_bp:ptr_new() $
		, bangx_bp:ptr_new() $
		, bangy_bp:ptr_new() $
		, togirange_bp:0 $ ; If set I range changes.

		; Central Panel
		, cwinid:0L, pixmapid:0L $ ; Window & Pixmap ID
		, xsize:0, ysize:0 $ ; Window Size
		, bangp:ptr_new() $ ; !p
		, bangx:ptr_new() $ ; !x
		, bangy:ptr_new() $ ; !y
		, bangz:ptr_new() $ ; !z
		, bangz_reset:ptr_new()	$ ; ?

		; Titles
		, title:'' $
		, xtitle:'' $
		, ytitle:''	$

		; Binning
		, xrebin:1 $
		, yrebin:1 $
		, xsmooth:1 $
		, ysmooth:1 $


		; ImageBase
		, log_scale:0 $

		; Misc.
		, xstart:0 $
		, ystart:0 $

		, tp:''$
;		, dcs_bkgd:0 $
		, qorangle:'' $ ; The Label from Q -> Angle or Angle -> Q Button


		; Pointers to the original state.
		, original_color_table:ptr_new() $


		, ix_plot_symbol:6 $
		, iy_plot_symbol:6 $

	}

return
end
