;$Id: trifenestra_leftpanelbase.pro,v 1.1 2002/07/05 17:59:50 amunter Exp $
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************
;
; Event Handlers for the Left Panel
;
pro oplpDraw,event
	widget_control,event.top,get_uvalue=self
	self -> oplpDrawEvent,event
	return
end
;*******************************************************************************
; The Left or The Right Mouse Button Press
;
pro trifenestra::oplpDrawEvent, event

	if n_elements(*self.y_lp) lt 2 then return

	if event.press eq 1 then begin
		; left button of the mouse
		widget_control,event.id, event_pro='oplpZoom'
		self.xstart = event.x
		self.ystart = event.y
	endif else if event.press eq 4 then begin
		; right button of the mouse
		!trifenestra.leftPanelState.bang_y.range = $
			[min(*self.x_lp),max(*self.x_lp)]
		!trifenestra.leftPanelState.bang_x.range = $
			[min(*self.y_lp),max(*self.y_lp)]
		self -> updateivsy
	endif
	return
end
;*******************************************************************************
; Zooming Event
;
pro oplpzoom, event
	widget_control, event.top, get_uvalue=self
	self -> oplpzoomevent, event
	return
end
;*******************************************************************************
;
;
pro trifenestra::oplpzoomEvent,event

	idl_state_restore, !trifenestra.leftPanelState

	wset,self.pixmapid_lp

	plot,*self.y_lp,*self.x_lp	$
		,xran=!x.range,ytit=self.ytitle,xtitle='I' $
		,yran=!y.range,xticks=2,pos=[.25,.2,.9,.9]	$
		,xmargin=[1,0],ystyle=1 $
		,psym= self.iy_plot_symbol
	errbarxy,*self.y_lp,*self.dy_lp,*self.x_lp
	wset,self.lpwinid
	device,copy=[0,0,self.xsize_lp,self.ysize_lp,0,0,self.pixMapid_lp] ; clean picture
	plots,[self.xstart,event.x,event.x,self.xstart,self.xstart]	$
		,[self.ystart,self.ystart,event.y,event.y,self.ystart],/device

if event.release eq 1 then begin
	widget_control,event.id,event_pro='oplpDraw'
	if abs(self.xstart[0]-event.x[0]) gt 10 	$
		or abs(self.ystart[0]-event.y[0]) gt 10 then begin

	zoombox = convert_coord( [self.xstart,event.x],[self.ystart,event.y]	$
				,/device,/to_data)

	!trifenestra.leftPanelState.bang_x.range = [min(zoombox[0,*]),max(zoombox[0,*])]
	!trifenestra.leftPanelState.bang_y.range = [min(zoombox[1,*]),max(zoombox[1,*])]
	self -> updateivsy
	endif
endif

return
end
;*******************************************************************************
;23456789 123456789 123456789 123465798 123456789 123456789 123465789 123456789
;       10        20        30        40        50        60        70        80
;*******************************************************************************

function trifenestra_leftPanelBase, base, xsize, ysize

	return, widget_draw( base $
		,xsize=xsize, ysize=ysize $
		,/button_events,/motion_event,event_pro='oplpdraw')

end